<template>
  <div class="q-pa-lg">
    <div class="row">
      <div class="col q-pa-md">
        <q-img
          :src="imageUrl[selected.min]"
          spinner-color="white"
          style="height: 350px; max-width: 40"
        ></q-img>
      </div>
      <div class="col q-pa-md">
        <q-img
          :src="imageUrl[selected.max]"
          spinner-color="white"
          style="height: 350px; max-width: 40"
        ></q-img>
      </div>
    </div>

    <q-card>
      <q-card-section>
        <div class="q-py-lg">
          <q-range v-if="images[1] != null"
            v-model="selected"
            :min="0"
            :max="imageUrl.length - 1"
            label-always
            color="primary"
          />
          <div v-else class="text-caption"><q-icon name="warning"/> Upload your images</div>
        </div>
      </q-card-section>
      <q-card-section>
        <div class="row q-pa-md justify-center">
          <div class="col" v-for="index in imageUrl.length" :key="index">
            <div v-if="imageUrl.length < 10 || ((index + 1)%(2*imageUrl.length/10) == 0)">
              <q-img
                :src="imageUrl[index - 1]"
                spinner-color="white"
                style="height: 70px;"
              ></q-img>
            </div>
          </div>
          <q-space />
        </div>
      </q-card-section>
    </q-card>
    <div class="row">
      <div class="q-py-md">
        <q-file
          v-model="images"
          label="Images"
          filled
          multiple
          counter
          accept=".png, .json"
          style="max-width: 600px"
          @update:model-value="handleUpload()">
          <template v-if="images.length > 0" v-slot:append>
            <q-icon
              name="cancel" 
              @click.stop.prevent="clearUpload" 
              class="cursor-pointer" />
          </template>
          <template v-slot:before>
            <q-icon name="folder_open" />
          </template>
        </q-file>
      </div>
      <q-space />
      <div class="q-pa-sm">
        <q-btn 
          label="Upload to NextCloud" 
          color="primary" 
          icon="cloud_upload" 
          @click="uploadFiles"/>
      </div>
    </div>
  </div>
</template>

<script>
import { ref } from 'vue'
import {JSZip} from 'jszip'
import { saveAs } from 'file-saver';

export default {
  setup () {
    var JSZip = require("jszip");

    const selected = ref({ min: 0, max: 2});
    const images = ref([]);
    const imageUrl = ref([]);

    const handleUpload = () => {
      imageUrl.value = [];

      var counter = 0;

      for(var i = 0; i < images.value.length; i++){
        if (images.value[i] && images.value[i].name.endsWith(".png")) {
          imageUrl.value[counter] = URL.createObjectURL(images.value[i]);
          counter++;
        }
        
        selected.value.max = imageUrl.value.length -1;
      }
    }

    const uploadFiles = async () => {
      var jsonList = []

      images.value.forEach((file) => {
        if(file.name.endsWith(".json")){
          jsonList.push(file)
        }
      })

      jsonList.sort((a, b) => {return (a.name.localeCompare(b.name))})
      imageUrl.value.sort()

      var zip = new JSZip();

      for (var i = selected.value.min; i <= selected.value.max; i++){

        zip.file((i + "_picture.png").padStart(16, "0"), urlToBlob(imageUrl.value[i]));
        zip.file((i + "_data.json").padStart(14, "0"), jsonList[i]);
      }

      zip.generateAsync({type:"blob"}).then(function (blob) {
          saveAs(blob, "data.zip");
      }, function (err) {
      });
    }

    const clearUpload = () => {
      images.value = []
      imageUrl.value = [];
    }


    async function urlToBlob(url){
      return await fetch(url).then(r => r.blob());
    }
    
    return { selected, images, imageUrl, handleUpload, clearUpload, uploadFiles }
  },
}
</script>